define(['./module', 'jquery', 'datejs', 'jeasing', 'jtransit', 'essemble', 'mcq', 'quiz'], function (controllers, jQuery, Date) {
    'use strict';
    
    controllers.controller("PlayController", ["$scope", "$state", "$timeout", "Idle", "$document", "settings", "safaricom", "properties", "currentAuth", "$q", function($scope, $state, $timeout, Idle, $document, settings, safaricom, properties, currentAuth, $q) {
	    
      	Idle.watch(); 	

      	$scope.authObj = safaricom.auth();

      	//$scope.currentAuth = currentAuth;

      	$scope.$on('IdleTimeout', function() {	        
	        settings.logout();       
	    });

	    $scope.$on('IdleStart', function() {
	        settings.notify('Idle timeout, you will be redirected to the home page.');
	    });

	    $scope.toTheTop = function() {

		    $document.scrollTopAnimated(0, 1000).then(function() {
		        //console.log('You just scrolled to the top!');
		    });
	    };

	    $timeout(function () {
	     	$scope.toTheTop();
	    },1000);
	     

	    jQuery(document).on( 'scroll', function(){
 
			if (jQuery(window).scrollTop() > 100) {
				jQuery('.scroll-top-wrapper').addClass('show');
			} else {
				jQuery('.scroll-top-wrapper').removeClass('show');
			}
			
		});	

		$scope.logout = function(){
            $scope.authObj.$signOut();
            $state.go('home.login');
        };

		$scope.login = function(){			
			$state.go('home.login');
		};	

		$scope.register = function(){
			$state.go('home.register');
		};

		$scope.logsign = function(){
			$state.go('home.logsign');
		}		

		$scope.active_user = properties.getActiveUser();

	    //Submit a new staff form

	    var quiz;

	    $scope.quiz_url = "resources/quiz/xml/safaricom.xml";

	    function init(){
	        //prevent body overflow and scrolling on iPad   
	        if(isiPad){
	            jQuery(".game").css("overflow","hidden");
	            jQuery(".game").css("position","fixed");		        }
	        
	        //create the screen object which loads the xml and creates all screen elements
	        quiz = new Screen({id:"myQuiz", xmlPath: $scope.quiz_url});
	        
	        //choose a target div
	        
	        var targetDiv = get("container");
	        
	        //load it
	        quiz.load(targetDiv,false);
	    }
	    
	    //kick off
	    $timeout(function () {	

	        init();

	    });	


	    $scope.saveStaffScore = function(details){
				
		    	if(details !== undefined){

		    		settings.show_wait();

					var today = Date.today().toString("d-MMM-yyyy");					

					var scores = {
						staff_id: $scope.active_user.uid,
						points: details.score,						 
						last_played: today,
						staff_name: $scope.active_user.staff_name,
						staff_email: $scope.active_user.staff_email,
						staff_phone: $scope.active_user.staff_phone
					};


					$q.all([
					   safaricom.createScore(scores),
					   settings.backupScores(scores)

					]).then(function(data) {

						var scores_response = data[0].data;
						var backup_response = data[1].data;

						if(scores_response != false){

					    	settings.hide_wait();
							settings.notify('You score has been saved. You can play again tomorrow!');

							$timeout(function(){
								$scope.logout();
							},5000);


					    }else{
					      	console.log('Server error: '+scores_response.message);
					    }


					    if(backup_response.success){

					    	console.log(backup_response.message);

					    }else{
					      	console.log('Server error: '+backup_response.message);
					    }

					},function(error) { 
					 	  settings.hide_wait();
					      console.log(error);
					});					
					

		        }//END OF if(details !== undefined){
		            
		        	

		    }; // END of $scope.saveStaffScore = function(details){




	     
	  }//END OF controllers.controller("SignupController",

	]);
});
