define(['./module', 'jquery', "jui", "keyboard"], function (directives, jQuery) {
    'use strict';
    directives.directive('keyboard', ['$timeout', '$window', function ($timeout, $window) {
        return {
        	restrict: 'A',            
            link: function (scope, element, attributes) {                
               
                //Activate the functionality after directive/DOM has finished rendering
                $timeout(function () {                   

                    var screenWidth = $window.innerWidth;

                    if((screenWidth == 1080) || (screenWidth == 1920)){

                        /*KEYBOARD*/
                        jQuery('#staff_email, #staff_name').keyboard({
                            layout: 'qwerty',
                            autoAccept: 'true',
                            tabNavigation: 'true',
                            usePreview: false,      
                            beforeClose: function(e, keyboard, el, accepted) {
                                jQuery('input.current').removeClass('current');
                                jQuery("body").css('padding-bottom', '0px');
                            }
                        });

                        jQuery('#staff_password, #staff_phone').keyboard({

                            layout: 'custom',
                            autoAccept: 'true',
                            tabNavigation: 'true',     
                            customLayout: {
                                'default': [
                                    '7 8 9',
                                    '4 5 6',
                                    '1 2 3',
                                    '0 {bksp}',
                                    '{accept}'
                                    ]
                            },
                            usePreview: false,      
                            beforeClose: function(e, keyboard, el, accepted) {
                                jQuery('input.current').removeClass('current');
                                jQuery("body").css('padding-bottom', '0px');
                            }
                        });

                    }                  

                });

            }
        };
    }]);	

});
