define(['./module', "wait", 'jquery'], function (services, waitMe, jQuery) {
        
    services.factory('settings', ["$timeout", "$q", "$http", "safaricom", "$state", function($timeout, $q, $http, safaricom, $state){
    	
      var host = 'http://www.izoneafrica.net/sdgs';
      //var host = 'http://localhost:3000';
                	
      var settings = { 

          host: host, 

          api_url: host+'/api/index.php/safaricom',

          notify : function(message){              
             
              jQuery('.notice_message').html(message);

              jQuery('.notifications').fadeIn(500,function(){
                  jQuery(this).css({"display":"block"});
                  jQuery('.overlay').css('display', 'block');
              });              

              $timeout(function() {
                
                jQuery('.notifications').fadeOut(500,function(){
                      jQuery(this).css({"display":"none"});
                      jQuery('.overlay').css('display', 'none');
                });

              }, 4000);

          },

          confirm : function(message){   

              var deferred = $q.defer();           
             
              jQuery('.confirm_message').html(message);

              jQuery('.confirm').fadeIn(500,function(){
                  jQuery(this).css({"display":"block"});
                  jQuery('.overlay').css('display', 'block');
              });              

              
              function close(){  
                jQuery('.confirm').fadeOut(500,function(){
                      jQuery(this).css({"display":"none"});
                      jQuery('.overlay').css('display', 'none');
                }); 
              } 

              jQuery('button.ok').on('click', function(){
                  close();
                  deferred.resolve(true);
              });

              jQuery('button.cancel').on('click', function(){
                  close();
                  deferred.resolve(false);
              });

              return deferred.promise;               

          },


          show_wait  : function(){ 

              var opts = {
                effect: 'pulse',
                text: 'Please wait...',
                bg: 'rgba(255,255,255,0.7)',
                color:'#ed1b24',
                sizeW:'',
                sizeH:'',
                source: 'img/img.svg'
              };

              var target = jQuery('.spinner');

              jQuery('.spinner-overlay').css('display', 'block');
              jQuery('.spinner').css('display', 'block');
              target.waitMe(opts);

          },

          hide_wait  : function(){

              var target = jQuery('.spinner');
              jQuery('.spinner-overlay').css('display', 'none');
              jQuery('.spinner').css('display', 'none');
              target.waitMe("hide");

          },

          logout: function(){
              var Auth = safaricom.auth();            
              Auth.$signOut();        
              $state.go('landing');              
          },

          
          checkAvailableEmail: function(email, type){

            var deferred = $q.defer(); 

            if(type == 'staff'){
              var staff = safaricom.allStaff(); //For staff query, when adding a new staff
            }else{
              var staff = safaricom.allUsers(); //For admin query when adding a new admin
            }                    

            //console.log(email);

            staff.$loaded().then(function(data){
              
                //console.log(data);

                staff = data;

                //console.log(staff.length);
                
                var status = false;

                if(staff.length > 0){                 

                  angular.forEach(staff, function(value) {  
                                         
                      if (value.staff_email == email) {
                         status = true;
                      }
                  }); 

                  deferred.resolve(status);                 

                }else{
                  deferred.resolve(status);
                }

            });//END OF staff.$loaded()

            return deferred.promise;

          },


          getPassword: function (passwd) {
                //console.log(passwd);
                var that = this; 
                return $http.get(that.api_url + '/password/'+passwd);

          },

          getStaffToken: function (staff) {

                var that = this; 
                return $http.get(that.api_url + '/staff/token/'+staff.staff_id);
          },
          

          staffLogin: function(staff){

              var that = this; 

              var postData = JSON.stringify({
                  'staff_email': staff.staff_email,
                  'staff_password': staff.staff_password
              });

              //console.log(postData);

              return $http({
                method: 'POST',
                url: that.api_url + '/staff/login/',
                headers: { 'Content-Type': 'application/json' },
                data: postData
              });

          },
          

          getLastScore: function () {

              return $http.get(api_url + '/lastscore/');

          },


          allScores: function () {

              return $http.get(api_url + '/scores/');
              
          },
            
          sendEmail: function () {

              var that = this;
              var date = new Date();
              var day = date.getDate();
              var month = date.getMonth();
              var year = date.getFullYear();
              var filename = day+'_'+month+'_'+year+'.pdf';

              var postData = JSON.stringify({
                  'document_name': filename
              });             

              $http({
                  url: that.api_url + '/email/', 
                  method: "POST", 
                  headers: { 'Content-Type': 'application/json' },
                  data: postData
              });
              
          },


          backupScores: function(score){

              var that = this; 

              var postData = JSON.stringify({
                  'staff_name': score.staff_name,                  
                  'staff_phone': score.staff_phone,
                  'staff_email': score.staff_email,
                  'points': score.points,             
                  'last_played': score.last_played
              });   

              
              return $http({
                method: 'POST',
                url: that.api_url + '/backup/scores/',
                headers: { 'Content-Type': 'application/json' },
                data: postData
              });

          },


          backupStaff: function(staff){

              var that = this; 

              var postData = JSON.stringify({
                  'staff_name': staff.staff_name,                  
                  'staff_phone': staff.staff_phone,
                  'staff_email': staff.staff_email
              }); 
                       

              return $http({
                method: 'POST',
                url: that.api_url + '/backup/staff/',
                headers: { 'Content-Type': 'application/json' },
                data: postData
              });

          },


          
      };    	

    	return settings;
      
    }]);

});
