//Configure all the files that the application needs
requirejs.config({
  baseUrl: "js",
  paths: {
    
    domReady: "vendor/domready/domReady",    
    jquery: "vendor/jquery/jquery-2.2.0.min",
    jeasing: "vendor/jquery-easing/jquery.easing.1.3",    
    fclick: "vendor/fastclick/fastclick",    
    ngscroll: "vendor/scroll/angular-scroll.min",    
    angularidle: "vendor/angular-idle/angular-idle.min",
    angular: "vendor/angular/angular.min",    
    angulartouch: "vendor/angular/angular-touch.min",
    angularmock: "vendor/angular/angular-mocks",    
    uiRouter: "vendor/uirouter/angular-ui-router.min",
    angularAnimate: "vendor/angular/angular-animate.min",
    ocLazyLoad: "vendor/oclazy/ocLazyLoad.require.min",
    back: "vendor/backstretch/jquery.backstretch.min",
    wait: "vendor/wait/waitMe.min",
    angularFire: "vendor/angular-fire/angularfire.min",
    fireBase: "vendor/firebase/firebase",
    jui: "vendor/jquery-ui/jquery-ui",
    juiwidget: "vendor/jquery-ui/jquery.ui.widget.min",
    juitouchpunch: "vendor/jquery-ui/jquery.ui.touch-punch.min",
    newsticker: "vendor/news-ticker/jquery.newsTicker.min",
    keyboard: "vendor/keyboard/jquery.keyboard.min",
    jtransit: "vendor/quiz/jquery.transit.min",
    essemble: "vendor/quiz/essemble_core.min",
    mcq: "vendor/quiz/mcq",
    quiz: "vendor/quiz/quiz",
    datejs: "vendor/date/date"
    
  },

  shim: {

	angular:{
        deps: ['jquery'],            
        exports: 'angular'
    },

    datejs: {
        exports: 'Date'
    },

    newsticker: {
        deps: ['jquery'],
        exports: 'newsTicker'
    },    
           
    uiRouter:{
        deps: ['angular']
    },

    ngscroll:{
        deps: ['angular']
    },

    angularidle:{
        deps: ['angular']
    },           

    ocLazyLoad:{
        deps: ['angular']
    },

    fireBase: {
        exports: 'Firebase'
    }, 

    angularFire: { 
        deps:["angular", "fireBase"]
    }, 

    back: {
        deps: ['jquery']
    },      

    wait:{
        deps: ['jquery'],
        exports: 'waitMe'
    },       
    
    angulartouch:{
        deps: ['angular']
    },

    angularmock:{
        deps: ['angular']
    },

    fclick:{
        deps: ['jquery']
    },

    angularAnimate:{
        deps: ['angular']
    },

    juiwidget: ["jquery"],

    jui: ["juiwidget"],    

    jeasing: ["jquery"],

    juitouchpunch: ["juiwidget"],
        
    keyboard: {
        deps: ["jquery", "jui", "juiwidget", "juitouchpunch"],
        exports: 'keyboard'
    },

    jtransit: {
        deps: ['jquery']
    },

    essemble: {
        deps: ['jeasing', 'jtransit']
    },

    mcq: {
        deps: ['essemble']
    },

    quiz: {
        deps: ['jquery', 'mcq']
    }
    
  },

  // kick start application
  deps: ['./bootstrap']

});
