/** define all the application routes 
 **/
define(['./app'], function(app) {
    'use strict';
    return app.config(["$stateProvider", "$urlRouterProvider", "$ocLazyLoadProvider", "IdleProvider", "KeepaliveProvider", "$sceDelegateProvider",  function($stateProvider, $urlRouterProvider, $ocLazyLoadProvider, IdleProvider, KeepaliveProvider, $sceDelegateProvider) {
        
        IdleProvider.idle(180); // in seconds
        IdleProvider.timeout(10); // in seconds
        KeepaliveProvider.interval(2); // in seconds


        $sceDelegateProvider.resourceUrlWhitelist([
            // Allow same origin resource loads.
            'self',
            // Allow loading from 192.168.1.* domain. 
            'http://192.168.1.*/**',

            // Allow loading from 192.168.0.* domain. 
            'http://192.168.0.*/**',

            // Allow loading from localhost domain. 
            'http://localhost/**'
        ]);
        
        
        $urlRouterProvider.otherwise('/landing');       
             
        //Home route 
        $stateProvider.state("landing", {
            url: "/landing",
            templateUrl: 'partials/landing.html',            
            controller:'LandingController'
        })

        .state("home", {            
            url: "/home",
            templateUrl: 'partials/home.html',                        
            controller:'SignupController'
        })
        

        .state("home.logsign", {            
            url: "/logsign",
            templateUrl: 'partials/logsign.html',
            controller:'SignupController'
        })

        .state("home.login", {            
            url: "/login",
            templateUrl: 'partials/login.html',
            controller:'SignupController'
        })


        .state("home.register", {            
            url: "/register",
            templateUrl: 'partials/register.html',
            controller:'SignupController'
        })

        .state("home.board", {            
            url: "/board",
            templateUrl: 'partials/board.html',
            controller:'SignupController'
        })


        .state("home.play", {
            url: "/play",
            templateUrl: 'partials/play.html',
            secure: true,                        
            controller:'PlayController',
            resolve: {
                currentAuth: ["safaricom", function(safaricom) {
                  return safaricom.auth().$requireSignIn();
                }]
            }
        });



        

          


    }])
});