var express = require('express');
var cors = require('cors');
var bodyParser = require('body-parser');
var bunyan = require('bunyan');
var firebase = require('firebase');
var passwordHash = require('password-hash');
var cluster = require('cluster');
var numCPUs = require('os').cpus().length;
var log = bunyan.createLogger({name: "sdgs-log"});

var app = express();

global.config = {
    apiKey: "AIzaSyA8o0CYglGaWowSCN_Tw8VVrFtoStZkD0s",
    authDomain: "sdgs-dev.firebaseapp.com",
    databaseURL: "https://sdgs-dev.firebaseio.com",
    storageBucket: "sdgs-dev.appspot.com",
    serviceAccount: {      
      "project_id": "sdgs-dev",
      "private_key_id": "a3f23398188f891ce1aeae1e2fa289b41b8e56bd",
      "private_key": "-----BEGIN PRIVATE KEY-----\nMIIEvQIBADANBgkqhkiG9w0BAQEFAASCBKcwggSjAgEAAoIBAQDSU5c8E2nddwqi\nLusa5eRRhaQE2HhjwlBHvI7pKR/vZGPNoZj75DGOJyc/4wE1nG9X++cCgeNwdvhs\nvk4VvEoIT/9WzEDv8o8bRPxwHgxOKGYHyAJALQ8QAGGx0ifa5N1nAhPaNuTzjGul\ncKfEoP/I5XjtPEmbR8E6RtQDw668ChYA+rGjTENgaX1AoTVsw0CgpB0xPNZIZy1f\nGyl3h1RefBfFAk4x/MaIE9WZcO0XBSgbehy7B/Y048P1l4iZR0ZIxNoa0tStJ81D\nbJR3p4uQEap/8tredKU+Bj/QapRnV8ksKYWu9G976utlGMdR+mR1WrcmtRM+jaoK\nxTj33RYPAgMBAAECggEABSAOVmNut/vXoX4dMomZl7b2+TtBK8UnaagZn2rmIVJD\n8FXYwYKdBobDuRXSCLloKS+1QGVj4nCzuwqkInl1IGC6qyXNC0vQ2uxCboT87cak\nPdpM2719WXl45/lkCTx8fK8bRr0BtUGduelV3T/DG+UjnjxS2trTxZTGQ9U349Mb\nxzcJIsGlncelyMcUxiOxR1VGQbYHUsesfKJH2Lm6miY310AIJjBPQ2kjFB6QTfxY\nGiV07CLCwHCpbSui4UmLBM4Au72n5Gp3h+IZGe+JwHZXcMp2jXeHkBecmf/D4/JY\nRa7/A6SSAkkENMoQHdxt7YJlCYqGoM9FLDr1LI21aQKBgQDwfrR2ECtA9k9yAqO8\nPvjmFU016PqKgKHzXylBamGbRtjlYfb+MHDsR3XYUJVMiDrIs1GqB1t+jZw2VR5/\nFpA7UVGvf4GBszWzgX30XJLcvo5Rv1ZMp0P01tU/LGlA7rA5nb/3cqp/3BJ12/qq\nsNhjslIhDZ8oUE4YVqS3sSz8RQKBgQDf4vcl96wXL2OxFca48XFR4ktEa1Gt6jxJ\nf+bt0jmMOkqNXNAY/NL0GwrqU/nbI8QbXF3RLyfqt5BZ4Gw0e8EXvCKb+vRomv19\nkZSzBA4pIK/D+OR5tVVkpDzp8Lr4yZGQg3gH9iTNV93Un/9ZZUDQhW0q3gE2N9ey\nfClBtxPQQwKBgDLbaIgrBSqYq9Y9TqjJXFMzn/9NhGXzq8vOjOfjej6e7dEcNWIt\nlkOxHO+gouHrURsOKK/fHG8XvTgUKf3QJLIWkUKeoSFvZ2TNdnhNd1UtCuWoo7RU\nDt/g6nmQh7WOhD+651SJsBqXzGOWIF0mRqxWkl2hBs48pTcqY2zhD9VNAoGAJqhV\n7GRbfpVcLVOJQJ3P50efn2y4acMsLbS79wx5i1D1VntUIzxkYGna9KMTXVdLoT3N\npTTzO3/+mMY7aMSFjseZYj1uvjEk2+2rM03b9BYEw13SdYFuATaqnepHHnYPgFhy\n/UzvBdXKI9CMkq79BgRD2UcEBoyV3ee6Z/JopWkCgYEApbgC+wsLNLSmx6r4yuRF\n3ZdI+GlqQU5jmcfkkw8d8i3qW3rTsDvQQdubp7oL8K9rJYhOvNpZ7sDNq3divNjr\nkfVPRcIEwqUGPnwl2lw1uGlmUqlRCYs+51MLQ7/bT6bIRpA/x3ZqNp0uAR32MHE0\nih0iSiYtClGfLcUknZJqfZo=\n-----END PRIVATE KEY-----\n",
      "client_email": "admin-79@sdgs-dev.iam.gserviceaccount.com",
      "client_id": "109155424584040681948",
      "auth_uri": "https://accounts.google.com/o/oauth2/auth",
      "token_uri": "https://accounts.google.com/o/oauth2/token",
      "auth_provider_x509_cert_url": "https://www.googleapis.com/oauth2/v1/certs",
      "client_x509_cert_url": "https://www.googleapis.com/robot/v1/metadata/x509/admin-79%40sdgs-dev.iam.gserviceaccount.com"
    }
  };

var fapp = firebase.initializeApp(global.config);
var ref = firebase.database().ref();
var auth = firebase.auth();

//app.use(express.static(__dirname + '/public')); //redirect all traffic on the public dir
app.use(express.static('public'));
app.use(cors()); //use the cors plugin
app.use(bodyParser.json());
app.use(bodyParser.urlencoded({ extended: true }));

//Redirect all traffic from the root to the index.html so that angular can handle the routing
app.get('/', function(req, res){
  res.redirect('/index.html');
});


//Get staff token
app.post('/staff/token/', function(req, res) {

  var data = {
              staff_name : req.body.staff_name, 
              staff_email : req.body.staff_email,
              staff_phone : req.body.staff_phone,              
              uid : req.body.key
            };

  var token = auth.createCustomToken(req.body.key);  

  res.json({ success: true, token: token, staff: data });
  
});


//Get token 
app.get('/user/:id', function(req, res) {
  
  var id = req.params.id, url = '/users/',logged_in_user = [];

  ref.child(url + id).once('value', function(snapshot) {
    var user = snapshot.val();
    logged_in_user = user;
    logged_in_user.password = null;
    var uid = user.key();
    
    var token = auth.createCustomToken(uid);

    res.json({ success: true, token: token, user: logged_in_user });

  }, function (error) {
      
      res.json({ success: false, error: error.code });

  }); 

});



//Get password
app.get('/password/:password', function(req, res) {

  var password = req.params.password;

  //Get password
  var hashedPassword = passwordHash.generate(password);
  var status = passwordHash.isHashed(hashedPassword);

  if(status){

  	res.json({ success: true, password: hashedPassword });

  }else{

  	res.json({ success: false, error: 'Sorry unable to generate password!' });

  }
  
});




//Login into the application
app.post('/staff/login', function(req, res) {

    var email = req.body.staff_email,
        password = req.body.staff_password,
    	  password_ok = false, 
    	  user_found = false,
    	  staff = {},
    	  user_id = '',
        url = '/staff/';

    ref.child(url).once('value', function(snapshot) {
	   

  	    snapshot.forEach(function(data) {

  	    	//log.info("The " + data.key() + " dinosaur's score is " + data.val());
  	    	var user = data.val();

  	    	if(email == user.staff_email){            
  	    		user_found = true;  	    		
  	    		password_ok = passwordHash.verify(password, user.staff_password);
  	    		staff = user;
  	    		user_id = data.key;
  	    	}

  	    });	  

  	    if(user_found){

    	    	//password ok
      			if(password_ok){

                var token = auth.createCustomToken(user_id);
                staff.staff_password = null;
                staff.uid = user_id;
                res.json({ success: true, token: token, staff: staff});

      			}else{
      				res.json({ success: false, error: 'Sorry!... Invalid Password' });
      			}

  	    }else{
  	    	res.json({ success: false, error: 'Sorry!... Invalid Username' });
  	    }

    }, function (error) {
      // code to handle read error
      res.json({ success: false, error: error.code });
    });//End of ref.once("value", function(snapshot)

    
});


//Confirm password
app.post('/confirm', function(req, res) {
    var username = req.body.username,
        password = req.body.password,
        password_ok = false, 
        user_found = false,
        user_id = '',
        url = '/users/';
        
        ref.child(url).once("value", function(snapshot) {
        
            snapshot.forEach(function(data) {

              //log.info("The " + data.key() + " dinosaur's score is " + data.val());
              var user = data.val();
              
              if(username == user.username){
                user_found = true;                
                password_ok = passwordHash.verify(password, user.password);                
                user_id = data.key();
              }

            });   

            if(user_found){

                //password ok
                if(password_ok){

                    res.json({ success: true, id: user_id });

                }else{
                  res.json({ success: false, error: 'Current password NOT correct!' });
                }

            }else{
              res.json({ success: false, error: 'Username not found!' });
            }

        }, function (error) {
          // code to handle read error
          res.json({ success: false, error: error.code });
        });//End of ref.once("value", function(snapshot) 

    
});


if (cluster.isMaster) {
  
  // Fork workers.
  for (var i = 0; i < numCPUs; i++) {
    cluster.fork();
  }

  cluster.on('death', function(worker) {
    log.info('worker ' + worker.pid + ' died');
  });

} else {

  app.listen(3000);
  log.info("server listening on port 3000");

}

